<?php
// Free Content 1.01 (c) J. Keith Tysinger


// We calling this directly, if so, your evil...
if (!defined('SMF'))
	die('Hacking attempt...');
	

function free_quote_select() 
{
	global $txt, $context, $modSettings, $scripturl, $options, $sourcedir, $user_settings;


//Check to see if any modules are checked
if (!empty($context['user']['is_guest']) || (empty($user_settings['free_bible']) &&  empty($user_settings['free_word']) && empty($user_settings['free_quote'])))
	return false;
	
if (!empty($user_settings['free_random'])) 
{

		do
		{
			$random = rand(0, 2);
			if (($random ==0) && ($user_settings['free_bible'])) {break;}
			if (($random ==1) && ($user_settings['free_quote'])) {break;}
			if (($random ==2) && ($user_settings['free_word'])) {break;}

			}
		while ( 1<>2 );

} else 
// Use module that is selected first in the list, since user does not want random content
{
			if ($user_settings['free_bible']) {$random=0;} elseif
			($user_settings['free_quote']) {$random=1;}
			else {$random=2;}
}

	switch ($random) {
	    case 0:
					$l = free_bible_quote_of_the_day();
    	    break;
	    case 1:
					$l = free_quote_of_the_day();
    	    break;
	    case 2:
					$l = free_webster_word_of_the_day();
    	    break;
}

return $l;
};


function free_quote_of_the_day() 
{
	global $modSettings, $txt;

if (($temp = cache_get_data('free_content_quote', 7200)) == null)
{

	$feed = file_get_contents('http://feeds2.feedburner.com/quotationspage/qotd');
	if (empty($feed)) return;
	
	preg_match_all('/<link>(.*)<\/link>/', $feed, $webster_word);
	preg_match_all('/<title>(.*)<\/title>/', $feed, $webster_title);
	preg_match_all('/<description>(.*)<\/description>/Us', $feed, $webster_content);

	$webster_title = $webster_title[1][2];
	$webster_word = $webster_word [1][2];
	$webster_content = $webster_content [1][2];

	$kc = preg_replace('/$.*/sm', '' , $webster_content,1);
	$str_length22 = strlen($kc);
		
		$kc = substr($kc, 1, $str_length22);
		$kc = substr($kc, 0, - 2);

    $search = array(chr(145), 
                    chr(146), 
                    chr(147), 
                    chr(148), 
                    chr(151)); 
 
    $replace = array("'", 
                     "'", 
                     '"', 
                     '"', 
                     '-'); 

$kc = str_replace($search, $replace, $kc); 
$kc = str_replace('"', '&#151;', $kc); 	
$kc = str_replace('�', '&#39;', $kc);

if (!empty($modSettings['cache_enable']))
			cache_put_data('free_content_quote', array ($kc,$webster_word,$webster_title), 7200);

} else  {$kc = $temp[0]; $webster_word = $temp[1]; $webster_title = $temp[2];}


$myfree= '<div class="freepicture">
		<div class="freepictureinside">
		<blockquote class="free">
		<div>
			'.$kc.'
		</div>
		</blockquote>
		<div class="freelinkspecs">
		<div class="classw1">&mdash; <a href="'.$webster_word.'" target="_blank">'.$webster_title.'</a>
			</div></div>
		<div class="freetitlemod">'.$txt['free_content_quote'].'</div>
		</div>
		</div>';

		
return $myfree;
}



function free_bible_quote_of_the_day()
{
	global $modSettings, $txt;

if (($temp = cache_get_data('free_content_bible', 7200)) == null)

{
	$feed = file_get_contents('http://www.biblegateway.com/votd/get/');
	if (empty($feed)) return;
	
	preg_match('/<permalink><!\[CDATA\[(.*)\]\]><\/permalink>/', $feed, $webster_word);
	preg_match('/<reference><!\[CDATA\[(.*)\]\]><\/reference>/', $feed, $webster_title);
	preg_match('/<text><!\[CDATA\[(.*)\]\]><\/text>/', $feed, $webster_content);
	
	$webster_word= $webster_word[1];
	$webster_title=$webster_title[1];
	$webster_content=$webster_content[1];

	$str_length22 = strlen($webster_content);
		
// Take out begining and ending quotation marks (may not be begining of verse)

if (substr_count($webster_content, '&ldquo;')<>0)
	{
		$webster_content= str_replace('&ldquo;', '', $webster_content);
		$webster_content= str_replace('&rdquo;', '', $webster_content);
	}

//	$webster_content= utf8_decode ($webster_content);


	$webster_word= str_replace('&', '&amp;', $webster_word);


		if (!empty($modSettings['cache_enable']))
			cache_put_data('free_content_bible', array($webster_content,$webster_word,$webster_title), 7200);

} else { $webster_content = $temp[0]; $webster_word = $temp[1]; $webster_title = $temp[2];}

    $search = array(chr(145), 
                    chr(146), 
                    chr(147), 
                    chr(148), 
                    chr(151)); 
 
    $replace = array("'", 
                     "'", 
                     '"', 
                     '"', 
                     '-'); 
 
 $webster_content = str_replace($search, $replace, $webster_content); 
 $webster_content = str_replace('"', '&#151;', $webster_content); 
 $webster_content = str_replace('�', '&#145;', $webster_content); 
 
	$myfree= '<div class="freepicture" > 
			<div class="freepictureinside">
				<blockquote class="free">
					<div>
						'.$webster_content.'
					</div>
				</blockquote>
				<div class="freelinkspecs">
				<div class="classw1"><a href="'.$webster_word.'" target="_blank">'.$webster_title.'</a></div></div>
			<div class="freetitlemod">'.$txt['free_content_bible'].'</div>
			</div>
		</div>';


return $myfree;

}


function free_webster_word_of_the_day()
{
	global $settings,$modSettings,$txt;


if (($temp_kc = cache_get_data('free_content_webster', 7200)) == null)

	{ 

	$feed = file_get_contents('http://www.merriam-webster.com/word/index.xml');

	if (empty($feed)) return;

	$pos1 = strpos($feed, '<description><![CDATA[' );
	$pos2 = strpos($feed, ']]></description>' );
	$webster_item = substr($feed, $pos1, $pos2-$pos1);    

	$pos1 = strpos($webster_item, '</strong></p>' );
	$webster_item = substr($webster_item, $pos1+13, strlen($webster_item));    

	$pos1 = strpos($webster_item, '<strong>' );
	$pos2 = strpos($webster_item, '</strong>' );
	$webster_title = substr($webster_item, $pos1+8, $pos2-$pos1-8);

	$kc = preg_replace("/^<p>/sm", "<p id='webster'>" , $webster_item,1);


	//Make Word a link to webster
	$kc = preg_replace("/<strong>(.*)<\/strong>/", "<span class=\"classw2\"><a href=\"http://www.merriam-webster.com/dictionary/".$webster_title."\" target=\"_blank\">$1" ,$kc,1);	
	$kc = preg_replace("/ &#149;/", "</a></span>&nbsp; &#149;" , $kc,1);	

	//Remove sample sentence caption -- to end 
	$kc = preg_replace("/^<\/p>.*<p>.*<strong>Example sentence:<\/strong><br \/>.*/sm", "" , $kc,1);

	//Add graphic and link to wav file	
	$kc = preg_replace("/&nbsp; &#149; <em>/", "&nbsp;<a href=\"http://www.merriam-webster.com/cgi-bin/audio.pl?".$webster_title."0001.wav=".$webster_title."\" onclick=\"return reqWin(this.href, 620, 300);\"><img src=\"".$settings['images_url']."/freeaudio.gif\" class=\"wav_gif\" alt=\"\" /></a>
	&#149; <em>" , $kc,1);

	$str_length22 = substr_count($kc, '</em><br />');

	if ($str_length22==1) {$kc = str_replace("</em><br />", "</em></p><div id='webster_definition'>", $kc); $kcoffset='</div>';}
	else {$kcoffset='';}


// Let's check to see if multiple definitions are given (1:  2:   3:) maybe four at the most
// If so create a table to seperate the numbers (1:) from the definitions so that multiline definitions
// have a nice margin. Also BOLD the numbers



$str_length2 = preg_match("/1[[:blank:]]+a+[[:blank:]]+:/", $kc);
$str_length22 = preg_match("/1[[:blank:]]+:/", $kc);

if (($str_length22==1) || ($str_length2==1))
	{ 
	
	if ($str_length2==1) $kc = preg_replace("/1[[:blank:]]+a+[[:blank:]]+:/", "<table cellpadding=\"0\" cellspacing=\"3\" width=\"100%\"><tr><td class= \"webster_table_width\"><strong>1 :</strong></td><td>a : ", $kc, 1);
else 
{
	if ($str_length22==1) $kc = preg_replace("/1[[:blank:]]+:/", "<table cellpadding=\"0\" cellspacing=\"3\" width=\"100%\"><tr><td class= \"webster_table_width\"><strong>1 :</strong></td><td>", $kc, 1);
}
	
	
	$str_length22 = preg_match("/2[[:blank:]]+a+[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/2[[:blank:]]+a+[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>2 :</strong></td><td>a : ", $kc, 1);
else 
{
	$str_length22 = preg_match("/2[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/2[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>2 :</strong></td><td>", $kc, 1);
}

	$str_length22 = preg_match("/3[[:blank:]]+a+[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/3[[:blank:]]+a+[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>3 :</strong></td><td>a : ", $kc, 1);
else 
{
	$str_length22 = preg_match("/3[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/3[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>3 :</strong></td><td>", $kc, 1);
}


	$str_length22 = preg_match("/4[[:blank:]]+a+[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/4[[:blank:]]+a+[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>4 :</strong></td><td>a : ", $kc, 1);
else 
{
	$str_length22 = preg_match("/4[[:blank:]]+:/", $kc);
	if ($str_length22==1) $kc = preg_replace("/4[[:blank:]]+:/", "</td></tr><tr><td class= \"webster_table_width\"><strong>4 :</strong></td><td>", $kc, 1);
}	

	$kc .="</td></tr></table>";
}
// Remove * -- the footnote character if only one if present. Otherwise leave * alone
$str_length22 = substr_count($kc, '*');
if ($str_length22==1) $kc = str_replace("*", "", $kc);

$kc = str_replace("<br />", "", $kc);
$temp_kc = $kc.$kcoffset;

		if (!empty($modSettings['cache_enable']))
			cache_put_data('free_content_webster', $temp_kc, 7200);

}
 //loaded from cache	


$myfree= '<div class="freepicture"> 
		<div class="freepictureinside">
		'.$temp_kc.'
		<div class="freetitlemod">'.$txt['free_content_webster'].'</div>
		</div>
		</div>';

return $myfree;
}